]> git.ipfire.org Git - people/pmueller/ipfire-2.x.git/blob - make.sh
Einige Dateien hatten perm:755...
[people/pmueller/ipfire-2.x.git] / make.sh
1 #!/bin/bash
2 ############################################################################
3 # #
4 # This file is part of the IPFire Firewall. #
5 # #
6 # IPFire is free software; you can redistribute it and/or modify #
7 # it under the terms of the GNU General Public License as published by #
8 # the Free Software Foundation; either version 2 of the License, or #
9 # (at your option) any later version. #
10 # #
11 # IPFire is distributed in the hope that it will be useful, #
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of #
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14 # GNU General Public License for more details. #
15 # #
16 # You should have received a copy of the GNU General Public License #
17 # along with IPFire; if not, write to the Free Software #
18 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19 # #
20 # Copyright (C) 2006 IPFire-Team <info@ipfire.eu>. #
21 # #
22 ############################################################################
23 #
24
25 NAME="IPFire" # Software name
26 SNAME="ipfire" # Short name
27 VERSION="2.0b" # Version number
28 SLOGAN="www.ipfire.org" # Software slogan
29 CONFIG_ROOT=/var/ipfire # Configuration rootdir
30 NICE=10 # Nice level
31 MAX_RETRIES=1 # prefetch/check loop
32 KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
33 MACHINE=`uname -m`
34 SVN_REVISION=`svn info | grep Revision | cut -c 11-`
35
36 IPFVER="full" # Which versions should be compiled? (full|light|devel)
37
38 # Set an information about the build number
39 if [ -e ./.svn ]; then
40 FIREBUILD=`cat .svn/entries |sed -n 's/^[ \t]*revision=\"// p' | sed -n 's/\".*$// p'`
41 fi
42
43 # Debian specific settings
44 if [ ! -e /etc/debian_version ]; then
45 FULLPATH=`which $0`
46 else
47 if [ -x /usr/bin/realpath ]; then
48 FULLPATH=`/usr/bin/realpath $0`
49 else
50 echo "ERROR: Need to do apt-get install realpath"
51 exit 1
52 fi
53 fi
54
55 PWD=`pwd`
56 BASENAME=`basename $0`
57 BASEDIR=`echo $FULLPATH | sed "s/\/$BASENAME//g"`
58 LOGFILE=$BASEDIR/log/_build.preparation.log
59 export BASEDIR LOGFILE
60 DIR_CHK=$BASEDIR/cache/check
61 mkdir $BASEDIR/log/ 2>/dev/null
62
63 # Include funtions
64 . tools/make-functions
65
66 if [ -f .config ]; then
67 . .config
68 else
69 echo -e "${BOLD}No configuration found!${NORMAL}"
70 echo -ne "Do you want to create one (y/N)?"
71 read CREATE_CONFIG
72 echo ""
73 if [ "$CREATE_CONFIG" == "y" ]; then
74 make_config
75 fi
76 fi
77
78 prepareenv() {
79 ############################################################################
80 # #
81 # Are we running the right shell? #
82 # #
83 ############################################################################
84 if [ ! "$BASH" ]; then
85 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
86 fi
87
88 if [ -z "${BASH_VERSION}" ]; then
89 exiterror "Not running BASH shell."
90 fi
91
92
93 ############################################################################
94 # #
95 # Trap on emergency exit #
96 # #
97 ############################################################################
98 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
99
100
101 ############################################################################
102 # #
103 # Resetting our nice level #
104 # #
105 ############################################################################
106 echo -ne "Resetting our nice level to $NICE" | tee -a $LOGFILE
107 renice $NICE $$ > /dev/null
108 if [ `nice` != "$NICE" ]; then
109 beautify message FAIL
110 exiterror "Failed to set correct nice level"
111 else
112 beautify message DONE
113 fi
114
115
116 ############################################################################
117 # #
118 # Checking if running as root user #
119 # #
120 ############################################################################
121 echo -ne "Checking if we're running as root user" | tee -a $LOGFILE
122 if [ `id -u` != 0 ]; then
123 beautify message FAIL
124 exiterror "Not building as root"
125 else
126 beautify message DONE
127 fi
128
129
130 ############################################################################
131 # #
132 # Checking for necessary temporary space #
133 # #
134 ############################################################################
135 echo -ne "Checking for necessary space on disk $BASE_DEV" | tee -a $LOGFILE
136 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
137 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
138 if (( 2048000 > $BASE_ASPACE )); then
139 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
140 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
141 beautify message FAIL
142 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
143 fi
144 else
145 beautify message DONE
146 fi
147
148 ############################################################################
149 # #
150 # Building Linux From Scratch system #
151 # #
152 ############################################################################
153 # Set umask
154 umask 022
155
156 # Set LFS Directory
157 LFS=$BASEDIR/build
158
159 # Check /tools symlink
160 if [ -h /tools ]; then
161 rm -f /tools
162 fi
163 if [ ! -a /tools ]; then
164 ln -s $BASEDIR/build/tools /
165 fi
166 if [ ! -h /tools ]; then
167 exiterror "Could not create /tools symbolic link."
168 fi
169
170 # Setup environment
171 set +h
172 LC_ALL=POSIX
173 MAKETUNING="-j6"
174 export LFS LC_ALL CFLAGS CXXFLAGS MAKETUNING
175 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
176
177 # Make some extra directories
178 mkdir -p $BASEDIR/build/{tools,etc,usr/src} 2>/dev/null
179 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
180 mkdir -p $BASEDIR/{cache,ccache} 2>/dev/null
181 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
182
183 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
184 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
185
186 # Make all sources and proc available under lfs build
187 mount --bind /dev $BASEDIR/build/dev
188 mount --bind /dev/pts $BASEDIR/build/dev/pts
189 mount --bind /dev/shm $BASEDIR/build/dev/shm
190 mount --bind /proc $BASEDIR/build/proc
191 mount --bind /sys $BASEDIR/build/sys
192 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
193 mount --bind $BASEDIR/ccache $BASEDIR/build/usr/src/ccache
194 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
195 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
196 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
197 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
198 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
199 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
200 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
201
202 # This is a temporary hack!!!
203 if [ ! -f /tools/bin/hostname ]; then
204 cp -f /bin/hostname /tools/bin/hostname 2>/dev/null
205 fi
206
207 # Run LFS static binary creation scripts one by one
208 export CCACHE_DIR=$BASEDIR/ccache
209 export CCACHE_HASHDIR=1
210
211 # Remove pre-install list of installed files in case user erase some files before rebuild
212 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
213 }
214
215 buildtoolchain() {
216 LOGFILE="$BASEDIR/log/_build.toolchain.log"
217 export LOGFILE
218 ORG_PATH=$PATH
219 NATIVEGCC=`gcc --version | grep GCC | awk {'print $3'}`
220 export NATIVEGCC GCCmajor=${NATIVEGCC:0:1} GCCminor=${NATIVEGCC:2:1} GCCrelease=${NATIVEGCC:4:1}
221 lfsmake1 ccache
222 lfsmake1 binutils PASS=1
223 lfsmake1 gcc PASS=1
224 export PATH=$BASEDIR/build/usr/local/bin:$BASEDIR/build/tools/bin:$PATH
225 lfsmake1 linux-libc-header
226 lfsmake1 glibc
227 lfsmake1 cleanup-toolchain PASS=1
228 lfsmake1 tcl
229 lfsmake1 expect
230 lfsmake1 dejagnu
231 lfsmake1 gcc PASS=2
232 lfsmake1 binutils PASS=2
233 lfsmake1 ncurses
234 lfsmake1 bash
235 lfsmake1 bzip2
236 lfsmake1 coreutils
237 lfsmake1 diffutils
238 lfsmake1 findutils
239 lfsmake1 gawk
240 lfsmake1 gettext
241 lfsmake1 grep
242 lfsmake1 gzip
243 lfsmake1 m4
244 lfsmake1 make
245 lfsmake1 patch
246 lfsmake1 perl
247 lfsmake1 sed
248 lfsmake1 tar
249 lfsmake1 texinfo
250 lfsmake1 util-linux
251 lfsmake1 cleanup-toolchain PASS=2
252 export PATH=$ORG_PATH
253 }
254
255 buildbase() {
256 LOGFILE="$BASEDIR/log/_build.base.log"
257 export LOGFILE
258 lfsmake2 stage2
259 lfsmake2 linux-libc-header
260 lfsmake2 man-pages
261 lfsmake2 glibc
262 lfsmake2 cleanup-toolchain PASS=3
263 lfsmake2 binutils
264 lfsmake2 gcc
265 lfsmake2 berkeley
266 lfsmake2 coreutils
267 lfsmake2 iana-etc
268 lfsmake2 m4
269 lfsmake2 bison
270 lfsmake2 ncurses
271 lfsmake2 procps
272 lfsmake2 sed
273 lfsmake2 libtool
274 lfsmake2 perl
275 lfsmake2 readline
276 lfsmake2 zlib
277 lfsmake2 autoconf
278 lfsmake2 automake
279 lfsmake2 bash
280 lfsmake2 bzip2
281 lfsmake2 diffutils
282 lfsmake2 e2fsprogs
283 lfsmake2 ed
284 lfsmake2 file
285 lfsmake2 findutils
286 lfsmake2 flex
287 lfsmake2 gawk
288 lfsmake2 gettext
289 lfsmake2 grep
290 lfsmake2 groff
291 lfsmake2 gzip
292 lfsmake2 inetutils
293 lfsmake2 iproute2
294 lfsmake2 kbd
295 lfsmake2 less
296 lfsmake2 libaal
297 lfsmake2 make
298 lfsmake2 man
299 lfsmake2 mktemp
300 lfsmake2 modutils
301 lfsmake2 mtd
302 lfsmake2 net-tools
303 lfsmake2 patch
304 lfsmake2 psmisc
305 lfsmake2 reiser4progs
306 lfsmake2 shadow
307 lfsmake2 sysklogd
308 lfsmake2 sysvinit
309 lfsmake2 tar
310 lfsmake2 texinfo
311 lfsmake2 udev
312 lfsmake2 util-linux
313 lfsmake2 vim
314 lfsmake2 grub
315 }
316
317 buildipfire() {
318 LOGFILE="$BASEDIR/log/_build.ipfire.log"
319 export LOGFILE
320 ipfiremake configroot
321 ipfiremake dhcp
322 ipfiremake dhcpcd
323 ipfiremake libusb
324 ipfiremake libpcap
325 ipfiremake linux-atm
326 ipfiremake ppp
327 ipfiremake rp-pppoe
328 ipfiremake unzip
329 ipfiremake linux SMP=1
330 ipfiremake ipp2p SMP=1
331 ipfiremake fcdsl SMP=1
332 ipfiremake fcdsl2 SMP=1
333 ipfiremake fcdslsl SMP=1
334 ipfiremake fcdslusb SMP=1
335 ipfiremake fcdslslusb SMP=1
336 ipfiremake fcpci SMP=1
337 # ipfiremake promise-sata-300-tx SMP=1
338 ipfiremake zaptel SMP=1
339 ipfiremake fuse SMP=1
340 ipfiremake linux
341 ipfiremake ipp2p
342 ipfiremake fcdsl
343 ipfiremake fcdsl2
344 ipfiremake fcdslsl
345 ipfiremake fcdslusb
346 ipfiremake fcdslslusb
347 ipfiremake fcpci
348 # ipfiremake promise-sata-300-tx
349 ipfiremake zaptel
350 ipfiremake fuse
351 ipfiremake pkg-config
352 ipfiremake cpio
353 ipfiremake expat
354 ipfiremake gdbm
355 ipfiremake gmp
356 ipfiremake pam
357 ipfiremake openssl
358 ipfiremake python
359 ipfiremake libnet
360 ipfiremake libjpeg
361 ipfiremake libpng
362 ipfiremake libtiff
363 ipfiremake lcms
364 ipfiremake libmng
365 ipfiremake freetype
366 ipfiremake libart
367 ipfiremake gd
368 ipfiremake popt
369 ipfiremake pcre
370 ipfiremake slang
371 ipfiremake newt
372 ipfiremake libcap
373 ipfiremake pciutils
374 ipfiremake libxml2
375 ipfiremake BerkeleyDB
376 ipfiremake mysql
377 ipfiremake cyrus-sasl
378 ipfiremake openldap
379 ipfiremake apache2
380 ipfiremake php
381 ipfiremake apache2 PASS=C
382 ipfiremake arping
383 ipfiremake beep
384 ipfiremake bind
385 ipfiremake capi4k-utils
386 ipfiremake cdrtools
387 ipfiremake dnsmasq
388 ipfiremake dosfstools
389 ipfiremake reiserfsprogs
390 ipfiremake squashfstools
391 ipfiremake sysfsutils
392 ipfiremake ntfs-3g
393 ipfiremake ethtool
394 ipfiremake ez-ipupdate
395 ipfiremake fcron
396 ipfiremake GD
397 ipfiremake GD-Graph
398 ipfiremake GD-TextUtil
399 ipfiremake gnupg
400 ipfiremake hdparm
401 ipfiremake ibod
402 ipfiremake initscripts
403 ipfiremake whatmask
404 ipfiremake iptables
405 ipfiremake libupnp
406 ipfiremake ipp2p IPT=1
407 ipfiremake moblock
408 ipfiremake linux-igd
409 ipfiremake ipac-ng
410 ipfiremake ipaddr
411 ipfiremake iptstate
412 ipfiremake iputils
413 ipfiremake l7-protocols
414 ipfiremake isapnptools
415 # ipfiremake isdn4k-utils # What about mISDN???
416 ipfiremake hwdata
417 ipfiremake kudzu
418 ipfiremake logrotate
419 ipfiremake logwatch
420 ipfiremake misc-progs
421 ipfiremake mtools
422 ipfiremake nano
423 ipfiremake nash
424 ipfiremake nasm
425 ipfiremake URI
426 ipfiremake HTML-Tagset
427 ipfiremake HTML-Parser
428 ipfiremake Compress-Zlib
429 ipfiremake Digest
430 ipfiremake Digest-SHA1
431 ipfiremake Digest-HMAC
432 ipfiremake libwww-perl
433 ipfiremake Net-DNS
434 ipfiremake Net-IPv4Addr
435 ipfiremake Net_SSLeay
436 ipfiremake IO-Stringy
437 ipfiremake Unix-Syslog
438 ipfiremake Mail-Tools
439 ipfiremake MIME-Tools
440 ipfiremake Net-Server
441 ipfiremake Convert-TNEF
442 ipfiremake Convert-UUlib
443 ipfiremake Archive-Tar
444 ipfiremake Archive-Zip
445 ipfiremake Text-Tabs+Wrap
446 ipfiremake Locale-Country
447 ipfiremake XML-Parser
448 ipfiremake glib
449 ipfiremake GeoIP
450 ipfiremake fwhits
451 ipfiremake noip_updater
452 ipfiremake ntp
453 ipfiremake openssh
454 ipfiremake openswan
455 ipfiremake pptpclient
456 ipfiremake rrdtool
457 ipfiremake setserial
458 ipfiremake setup
459 ipfiremake snort
460 ipfiremake snortsnarf
461 ipfiremake oinkmaster
462 ipfiremake squid
463 ipfiremake squid-graph
464 ipfiremake squidguard
465 ipfiremake calamaris
466 ipfiremake tcpdump
467 ipfiremake traceroute
468 ipfiremake vlan
469 ipfiremake wireless
470 ipfiremake libsafe
471 ipfiremake 3c5x9setup
472 ipfiremake pakfire
473 ipfiremake java
474 ipfiremake bootsplash
475 ipfiremake spandsp
476 ipfiremake lzo
477 ipfiremake openvpn
478 ipfiremake pammysql
479 ipfiremake ghostscript
480 ipfiremake cups
481 ipfiremake samba
482 ipfiremake sudo
483 ipfiremake mc
484 ipfiremake wget
485 ipfiremake bridge-utils
486 ipfiremake screen
487 ipfiremake hddtemp
488 ipfiremake smartmontools
489 ipfiremake htop
490 ipfiremake postfix
491 ipfiremake fetchmail
492 ipfiremake cyrusimap
493 ipfiremake webcyradm
494 ipfiremake mailx
495 ipfiremake clamav
496 ipfiremake spamassassin
497 ipfiremake amavisd
498 ipfiremake stund
499 ipfiremake libpri
500 # ipfiremake bristuff
501 ipfiremake asterisk
502 ipfiremake mpg123
503 ipfiremake libmad
504 ipfiremake libogg
505 ipfiremake libvorbis
506 ipfiremake lame
507 ipfiremake sox
508 ipfiremake gnump3d
509 ipfiremake applejuice
510 ipfiremake ocaml
511 ipfiremake mldonkey
512 ipfiremake rsync
513 ipfiremake tcpwrapper
514 ipfiremake portmap
515 ipfiremake nfs
516 ipfiremake nmap
517 ipfiremake mbmon
518 ipfiremake iftop
519 ipfiremake ncftp
520 ipfiremake cftp
521 ipfiremake etherwake
522 ipfiremake ethereal
523 ipfiremake tftp-hpa
524 ipfiremake bwm-ng
525 ipfiremake tripwire
526 ipfiremake sysstat
527 }
528
529 buildinstaller() {
530 # Run installer scripts one by one
531 LOGFILE="$BASEDIR/log/_build.installer.log"
532 export LOGFILE
533 ipfiremake syslinux
534 ipfiremake as86
535 ipfiremake mbr
536 ipfiremake memtest
537 installmake linux-libc-header
538 installmake binutils
539 ipfiremake uClibc PASS=1
540 ipfiremake gcc INST=1
541 installmake uClibc PASS=2
542 installmake gcc INST=2
543 installmake uClibc PASS=3
544 installmake busybox
545 installmake udev
546 installmake slang
547 installmake newt
548 installmake gettext
549 installmake kbd
550 installmake popt
551 installmake sysvinit
552 installmake misc-progs
553 installmake e2fsprogs
554 installmake libaal
555 installmake reiser4progs
556 installmake reiserfsprogs
557 installmake sysfsutils
558 installmake util-linux
559 installmake pciutils
560 installmake zlib
561 installmake mtd
562 installmake wget
563 installmake hwdata
564 installmake kudzu
565 installmake installer
566 installmake initrd
567 }
568
569 buildpackages() {
570 LOGFILE="$BASEDIR/log/_build.packages.log"
571 export LOGFILE
572 echo "... see detailed log in _build.*.log files" >> $LOGFILE
573
574 installmake strip
575
576 # Generating list of packages used
577 echo -n "Generating packages list from logs" | tee -a $LOGFILE
578 rm -f $BASEDIR/doc/packages-list
579 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
580 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
581 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
582 fi
583 done
584 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
585 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$' \
586 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
587 rm -f $BASEDIR/doc/packages-list
588 # packages-list.txt is ready to be displayed for wiki page
589 beautify message DONE
590
591 # Create images for install
592 if [ "$DEVEL" == "1" ]; then
593 ipfiremake cdrom ED=devel
594 fi
595 ipfiremake cdrom ED=full
596
597 # Check if there is a loop device for building in virtual environments
598 if [ -e /dev/loop0 ]; then
599 ipfiremake usb-stick
600 fi
601 ipfiremake pxe
602 mv $LFS/install/images/{*.iso,*.tgz,*.img.gz} $BASEDIR >> $LOGFILE 2>&1
603
604 ipfirepackages
605
606 # Cleanup
607 stdumount
608 rm -rf $BASEDIR/build/tmp/*
609
610 # Generating total list of files
611 echo -n "Generating files list from logs" | tee -a $LOGFILE
612 rm -f $BASEDIR/log/FILES
613 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
614 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
615 echo "##" >>$BASEDIR/log/FILES
616 echo "## `basename $i`" >>$BASEDIR/log/FILES
617 echo "##" >>$BASEDIR/log/FILES
618 cat $i | sed "s%^\./%#%" | sort >> $BASEDIR/log/FILES
619 fi
620 done
621 beautify message DONE
622
623 cd $PWD
624 }
625
626 ipfirepackages() {
627 # ipfiredist amavisd
628 # ipfiredist applejuice
629 # ipfiredist asterisk
630 ipfiredist clamav
631 # ipfiredist cups
632 # ipfiredist cyrusimap
633 # ipfiredist fetchmail
634 # ipfiredist gnump3d
635 # ipfiredist java
636 # ipfiredist mailx
637 # ipfiredist mldonkey
638 # ipfiredist nfs
639 # ipfiredist postfix
640 ipfiredist samba
641 # ipfiredist sox
642 # ipfiredist spamassassin
643 ipfiredist tripwire
644 # ipfiredist webcyradm
645 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
646 mv -f $LFS/install/packages/* $BASEDIR/packages >> $LOGFILE 2>&1
647 rm -rf $BASEDIR/build/install/packages/*
648 }
649
650 # See what we're supposed to do
651 case "$1" in
652 build)
653 clear
654 BUILDMACHINE=`uname -m`
655 DEVEL=0
656 if [ "$2" == "--devel" ]; then
657 DEVEL=1
658 fi
659 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz 2> /dev/null | head -n 1`
660 #only restore on a clean disk
661 if [ ! -f log/cleanup-toolchain-2-tools ]; then
662 if [ ! -n "$PACKAGE" ]; then
663 beautify build_stage "Full toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
664 prepareenv
665 buildtoolchain
666 else
667 PACKAGENAME=${PACKAGE%.tar.gz}
668 beautify build_stage "Packaged toolchain compilation"
669 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
670 tar zxf $PACKAGE
671 prepareenv
672 else
673 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
674 fi
675 fi
676 else
677 echo -n "Using installed toolchain" | tee -a $LOGFILE
678 beautify message SKIP
679 prepareenv
680 fi
681
682 beautify build_start
683 beautify build_stage "Building LFS"
684 buildbase
685
686 beautify build_stage "Building IPFire"
687 buildipfire
688
689 # Setzen des IPFire Builds
690 if [ "$FIREBUILD" ]; then
691 echo "$FIREBUILD" > $BASEDIR/build/var/ipfire/firebuild
692 else
693 echo "_(OvO)_" > $BASEDIR/build/var/ipfire/firebuild
694 fi
695
696 beautify build_stage "Building installer"
697 buildinstaller
698
699 beautify build_stage "Building packages"
700 buildpackages
701 beautify build_end
702 ;;
703 shell)
704 # enter a shell inside LFS chroot
705 # may be used to changed kernel settings
706 prepareenv
707 entershell
708 ;;
709 changelog)
710 echo -n "Loading new Changelog from SVN: "
711 svn log http://svn.ipfire.org/svn/ipfire > doc/ChangeLog
712 beautify message DONE
713 ;;
714 clean)
715 echo -en "${BOLD}Cleaning build directory...${NORMAL}"
716 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
717 $LOSETUP -d $i 2>/dev/null
718 done
719 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
720 umount $i
721 done
722 stdumount
723 for i in `seq 0 7`; do
724 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
725 umount /dev/loop${i} 2>/dev/null;
726 losetup -d /dev/loop${i} 2>/dev/null;
727 fi;
728 done
729 rm -rf $BASEDIR/build
730 rm -rf $BASEDIR/cdrom
731 rm -rf $BASEDIR/packages
732 rm -rf $BASEDIR/log
733 if [ -h /tools ]; then
734 rm -f /tools
735 fi
736 beautify message DONE
737 ;;
738 downloadsrc)
739 if [ ! -d $BASEDIR/cache ]; then
740 mkdir $BASEDIR/cache
741 fi
742 mkdir -p $BASEDIR/log
743 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
744 FINISHED=0
745 cd $BASEDIR/lfs
746 for c in `seq $MAX_RETRIES`; do
747 if (( FINISHED==1 )); then
748 break
749 fi
750 FINISHED=1
751 cd $BASEDIR/lfs
752 for i in *; do
753 if [ -f "$i" -a "$i" != "Config" ]; then
754 echo -ne "Loading $i"
755 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
756 if [ $? -ne 0 ]; then
757 beautify message FAIL
758 FINISHED=0
759 else
760 if [ $c -eq 1 ]; then
761 beautify message DONE
762 fi
763 fi
764 fi
765 done
766 done
767 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
768 ERROR=0
769 for i in *; do
770 if [ -f "$i" -a "$i" != "Config" ]; then
771 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
772 if [ $? -ne 0 ]; then
773 echo -ne "MD5 difference in lfs/$i"
774 beautify message FAIL
775 ERROR=1
776 fi
777 fi
778 done
779 if [ $ERROR -eq 0 ]; then
780 echo -ne "${BOLD}all files md5sum match${NORMAL}"
781 beautify message DONE
782 else
783 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
784 beautify message FAIL
785 fi
786 cd - >/dev/null 2>&1
787 ;;
788 toolchain)
789 clear
790 prepareenv
791 beautify build_stage "Toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
792 buildtoolchain
793 BUILDMACHINE=`uname -m`
794 echo "`date -u '+%b %e %T'`: Create toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
795 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
796 cd $BASEDIR && tar -zc --exclude='log/_build.*.log' -f cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
797 build/{bin,etc,usr/bin,usr/local} \
798 build/tools/{bin,etc,*-linux-gnu,include,lib,libexec,sbin,share,var} \
799 log >> $LOGFILE
800 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
801 > cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.md5
802 stdumount
803 ;;
804 gettoolchain)
805 BUILDMACHINE=`uname -m`
806 # arbitrary name to be updated in case of new toolchain package upload
807 PACKAGE=$SNAME-$VERSION-toolchain-$BUILDMACHINE
808 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.gz ]; then
809 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
810 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
811 echo "`date -u '+%b %e %T'`: Load toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
812 cd $BASEDIR/cache/toolchains
813 wget $URL_TOOLCHAIN/$PACKAGE.tar.gz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
814 if [ $? -ne 0 ]; then
815 echo "`date -u '+%b %e %T'`: error downloading toolchain for $BUILDMACHINE machine" | tee -a $LOGFILE
816 else
817 if [ "`md5sum $PACKAGE.tar.gz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
818 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
819 else
820 exiterror "$PACKAGE.md5 did not match, check downloaded package"
821 fi
822 fi
823 else
824 echo "Toolchain is already downloaded. Exiting..."
825 fi
826 ;;
827 othersrc)
828 prepareenv
829 echo -ne "`date -u '+%b %e %T'`: Build sources iso for $MACHINE" | tee -a $LOGFILE
830 chroot $LFS /tools/bin/env -i HOME=/root \
831 TERM=$TERM PS1='\u:\w\$ ' \
832 PATH=/usr/local/bin:/bin:/usr/bin:/sbin:/usr/sbin \
833 VERSION=$VERSION NAME="$NAME" SNAME="$SNAME" MACHINE=$MACHINE \
834 /bin/bash -x -c "cd /usr/src/lfs && make -f sources-iso LFS_BASEDIR=/usr/src install" >>$LOGFILE 2>&1
835 mv $LFS/install/images/ipfire-* $BASEDIR >> $LOGFILE 2>&1
836 if [ $? -eq "0" ]; then
837 beautify message DONE
838 else
839 beautify message FAIL
840 fi
841 stdumount
842 ;;
843 svn)
844 case "$2" in
845 update|up)
846 # clear
847 echo -ne "Loading the latest source files...\n"
848 if [ $3 ]; then
849 svn update -r $3 | tee -a $PWD/log/_build.svn.update.log
850 else
851 svn update | tee -a $PWD/log/_build.svn.update.log
852 fi
853 if [ $? -eq "0" ]; then
854 beautify message DONE
855 else
856 beautify message FAIL
857 exit 1
858 fi
859 echo -ne "Writing the svn-info to a file"
860 svn info > $PWD/svn_status
861 if [ $? -eq "0" ]; then
862 beautify message DONE
863 else
864 beautify message FAIL
865 exit 1
866 fi
867 chmod 755 $0
868 exit 0
869 ;;
870 commit|ci)
871 clear
872 if [ -f /usr/bin/mcedit ]; then
873 export EDITOR=/usr/bin/mcedit
874 fi
875 if [ -f /usr/bin/nano ]; then
876 export EDITOR=/usr/bin/nano
877 fi
878 echo -ne "Selecting editor $EDITOR..."
879 beautify message DONE
880 if [ -e /sbin/yast ]; then
881 if [ "`echo $SVN_REVISION | cut -c 3`" -eq "0" ]; then
882 $0 changelog
883 fi
884 fi
885 update_langs
886 svn commit
887 $0 svn up
888 if [ -n "$FTP_CACHE_URL" ]; then
889 $0 uploadsrc
890 fi
891 ;;
892 dist)
893 if [ $3 ]; then
894 SVN_REVISION=$3
895 fi
896 if [ -f ipfire-source-r$SVN_REVISION.tar.gz ]; then
897 echo -ne "REV $SVN_REVISION: SKIPPED!\n"
898 exit 0
899 fi
900 echo -en "REV $SVN_REVISION: Downloading..."
901 svn export http://svn.ipfire.org/svn/ipfire/trunk ipfire-source/ --force > /dev/null
902 svn log http://svn.ipfire.org/svn/ipfire/trunk -r 1:$SVN_REVISION > ipfire-source/Changelog
903 #svn info http://svn.ipfire.org/svn/ipfire/trunk -r $SVN_REVISION > ipfire-source/svn_status
904 evaluate 1
905
906 echo -en "REV $SVN_REVISION: Compressing files..."
907 if [ -e ipfire-source/trunk/make.sh ]; then
908 chmod 755 ipfire-source/trunk/make.sh
909 fi
910 tar cfz ipfire-source-r$SVN_REVISION.tar.gz ipfire-source
911 evaluate 1
912 echo -en "REV $SVN_REVISION: Cleaning up..."
913 rm ipfire-source/ -r
914 evaluate 1
915 ;;
916 diff|di)
917 update_langs
918 echo -ne "Make a local diff to last svn revision"
919 svn diff > ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff
920 evaluate 1
921 echo "Diff was successfully saved to ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff"
922 svn status
923 ;;
924 esac
925 ;;
926 uploadsrc)
927 PWD=`pwd`
928 cd $BASEDIR/cache/
929 echo -e "Uploading cache to ftp server:"
930 ncftpls -u $FTP_CACHE_USER -p $FTP_CACHE_PASS ftp://$FTP_CACHE_URL$FTP_CACHE_PATH/ > /tmp/ftplist
931 for i in *; do
932 if [ "$i" == "toolchains" ]; then continue; fi
933 grep -q $i /tmp/ftplist
934 if [ "$?" -ne "0" ]; then
935 echo -ne "$i"
936 ncftpput -u $FTP_CACHE_USER -p $FTP_CACHE_PASS $FTP_CACHE_URL $FTP_CACHE_PATH/ $i
937 if [ "$?" -ne "0" ]; then
938 beautify message FAIL
939 fi
940 fi
941 done
942 rm -f /tmp/ftplist
943 cd $PWD
944 exit 0
945 ;;
946 upload)
947 case "$2" in
948 iso)
949 echo -e "Uploading the iso to $FTP_ISO_PATH/$SVN_REVISION."
950 cat <<EOF > .ftp-commands
951 mkdir -p $FTP_ISO_PATH/$SVN_REVISION
952 ls -lah
953 quit
954 EOF
955 ncftp -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL < .ftp-commands
956 rm -f .ftp-commands
957 md5sum ipfire-$VERSION.$MACHINE-full.iso > ipfire-$VERSION.$MACHINE-full.iso.md5
958 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ ipfire-$VERSION.$MACHINE-full.iso
959 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ ipfire-$VERSION.$MACHINE-full.iso.md5
960 if [ -e ipfire-$VERSION.$MACHINE-devel.iso ]; then
961 md5sum ipfire-$VERSION.$MACHINE-devel.iso > ipfire-$VERSION.$MACHINE-devel.iso.md5
962 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ ipfire-$VERSION.$MACHINE-devel.iso
963 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ ipfire-$VERSION.$MACHINE-devel.iso.md5
964 fi
965 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ ipfire-source-r$SVN_REVISION.tar.gz
966 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ svn_status
967 if [ "$?" -eq "0" ]; then
968 echo -e "The iso of Revision $SVN_REVISION was successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
969 else
970 echo -e "There was an error while uploading the iso to the ftp server."
971 exit 1
972 fi
973 if [ "$3" = "--with-sources-cd" ]; then
974 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH/$SVN_REVISION/ ipfire-sources-cd-$VERSION.$MACHINE.iso
975 fi
976 ;;
977 paks)
978 cat <<EOF > .ftp-commands
979 mkdir -p $FTP_ISO_PATH/$SVN_REVISION/paks
980 ls -lah
981 quit
982 EOF
983 ncftp -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL < .ftp-commands
984 rm -f .ftp-commands
985 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/paks packages/*
986 if [ "$?" -eq "0" ]; then
987 echo -e "The packages were successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
988 else
989 echo -e "There was an error while uploading the packages to the ftp server."
990 exit 1
991 fi
992 ;;
993 esac
994 ;;
995 batch)
996 if [ "$2" = "--background" ]; then
997 batch_script
998 exit $?
999 fi
1000 if [ `screen -ls | grep -q ipfire` ]; then
1001 echo "Build is already running, sorry!"
1002 exit 1
1003 else
1004 if [ "$2" = "--rebuild" ]; then
1005 export IPFIRE_REBUILD=1
1006 echo "REBUILD!"
1007 else
1008 export IPFIRE_REBUILD=0
1009 fi
1010 echo -en "${BOLD}***IPFire-Batch-Build is starting...${NORMAL}"
1011 screen -dmS ipfire $0 batch --background
1012 evaluate 1
1013 exit 0
1014 fi
1015 ;;
1016 watch)
1017 watch_screen
1018 ;;
1019 pxe)
1020 case "$2" in
1021 start)
1022 start_tftpd
1023 ;;
1024 stop)
1025 stop_tftpd
1026 ;;
1027 reload|restart)
1028 reload_tftpd
1029 ;;
1030 esac
1031 exit 0
1032 ;;
1033 lang)
1034 update_langs
1035 ;;
1036 packages)
1037 case "$2" in
1038 sign)
1039 sign_packages
1040 ;;
1041 esac
1042 ;;
1043 "")
1044 clear
1045 svn info
1046 select name in "Exit" "IPFIRE: Downloadsrc" "IPFIRE: Build (silent)" "IPFIRE: Watch Build" "IPFIRE: Batch" "IPFIRE: Clean" "SVN: Commit" "SVN: Update" "SVN: Status" "SVN: Diff" "LOG: Tail" "Help"
1047 do
1048 case $name in
1049 "IPFIRE: Downloadsrc")
1050 $0 downloadsrc
1051 ;;
1052 "IPFIRE: Build (silent)")
1053 $0 build-silent
1054 ;;
1055 "IPFIRE: Watch Build")
1056 $0 watch
1057 ;;
1058 "IPFIRE: Batch")
1059 $0 batch
1060 ;;
1061 "IPFIRE: Clean")
1062 $0 clean
1063 ;;
1064 "SVN: Update")
1065 $0 svn update
1066 ;;
1067 "Help")
1068 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1069 cat doc/make.sh-usage
1070 ;;
1071 "LOG: Tail")
1072 tail -f log/_*
1073 ;;
1074 "Exit")
1075 break
1076 ;;
1077 esac
1078 done
1079 ;;
1080 config)
1081 make_config
1082 ;;
1083 *)
1084 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1085 cat doc/make.sh-usage
1086 ;;
1087 esac